/*-----------------------------------------------------*/
/*--	Micro-EMPIX Display Drivers (High)(DispHigh.c)-*/
/*--    Ver 1.0 (c) 2004                              -*/
/*--	E             -*/
/*--    ==================================            -*/
/*--    .                  -*/
/*--    .                        -*/
/*--    ..                       -*/
/*-----------------------------------------------------*/

#ifndef _DISPLOW_H_
	#define _DISPLOW_H_
	#include "displow.h"
#endif

/* ====================================================*/
/* ============== Function Prototypes =================*/
/* ====================================================*/

void PrintString (int x, int y, char *str,int length);
void PrintInteger (int x, int y, int number);
void PrintHex(int x, int y, unsigned int number);
void cls(void);

void bPrintString (char *str,int length);
void bPrintStr(char *string);
void bPrintInteger (int x);


/*==========================================================================================*/
/*=====================  O (MEMORY MAPPED) =====================================*/
/*==========================================================================================*/

/*   string   x,y.   length  */

void PrintString (int x, int y, char *str,int length)
{
	int i;
	for (i=0;i<length;i++)
		PrintChar (x+i,y,str[i]);
}

/*   string   x,y.     */
/*    NULL */

void PrintStr(int x, int y, char *string)
{
	char *ptr;

	for(ptr = string; *ptr; ptr++)
		PrintChar(x+(ptr - string), y, *ptr);
}

/*      x,y */

void PrintInteger (int x, int y, int number)
{
	int remainder;
	int divisor;
	int pos;
	char temp;

	remainder=number;
	divisor=10000;
	pos=x;
	while (divisor>0)
	{
		temp=remainder/divisor;
		remainder=remainder-temp*divisor;
		divisor=divisor/10;
		/* Now temp has the appropriate decimal digit */
		PrintChar (pos,y,0x30+temp);
		pos ++;
	}
}

/*      x,y */

void PrintHex(int x, int y, unsigned int number)
{
    int pos, shift;
	char temp;
	unsigned int mask;

    mask = 0xF000;
    pos = x;
    shift = 12;
    while(mask)
    {
		temp = (number & mask) >> shift;
        mask >>= 4;
        shift -= 4;
        if(temp > 9)
			PrintChar(pos, y, 'a' + temp - 10);
        else
            PrintChar(pos, y, '0' + temp);
        pos++;
    }
}

/*    */

void cls(void)
{
	int i;
	int j;
	for (i=0;i<80;i++)
		for (j=0;j<24;j++)
			PrintChar (i,j,' ');
}

/*==========================================================================================*/
/*==============================  O (BIOS) =====================================*/
/*==========================================================================================*/

/*  string       .   length */
/*  */

void bPrintString (char *str,int length)
{
	int i;
	for (i=0;i<length;i++)
		bPrintChar(str[i]);
}

/*  string       .   */
/*     NULL  */

void bPrintStr(char *string)
{
	char *ptr;

	for(ptr = string; *ptr; ptr++)
		bPrintChar(*ptr);
}

/*    x */

void bPrintInteger (int x)
{
	int remainder;
	int divisor;
	char temp;
	int start = 1;

	if(x == 0)
	{
		bPrintChar('0');
		return;
	}

	if(x < 0)
		bPrintChar('-');

	remainder=x<0 ? x*(-1) : x;
	divisor=10000;
	while (divisor>0)
	{
		temp=remainder/divisor;
		remainder=remainder-temp*divisor;
		divisor=divisor/10;  /* T  temp      */
		if(start != 1 || temp != 0)
		{
			bPrintChar('0'+temp);
			start = 0;
		}
	}
}
