/*-----------------------------------------------------*/
/*--	Micro-EMPIX Generic Clockfunctions (Clock.c)  -*/
/*--    Ver 1.0 (c) 2004                              -*/
/*--	E             -*/
/*--    ==================================            -*/
/*--    .                  -*/
/*--    .                        -*/
/*--    . .                      -*/
/*-----------------------------------------------------*/

#ifndef _DEFS_H
	#define _DEFS_H
	#include "defs.h"
#endif

#ifndef _PROC_H
	#define _PROC_H
	#include "proc.h"
#endif

#ifndef _ASM_H
	#define _ASM_H
	#include "asm.h"
#endif

/* ====================================================*/
/* ============== Function Prototypes =================*/
/* ====================================================*/
void setclkrate();
void interrupt clkint();
void clkinit();


static void interrupt (*IrqHandler_For_Clk)(); /*    */


/* H  setclkrate       */

void setclkrate()
{
	unsigned long count;
	unsigned low_byte, high_byte;
	int ps;

	disabl_intr(&ps); /*    */

	count = (unsigned long)(23863);
	low_byte  = (unsigned)(count & 0xFF);
	high_byte = (unsigned)((count >> 8) & 0xFF);
	port_out(0x43, 0, 0x36);
	port_out(0x40, 0, low_byte);
	port_out(0x40, 0, high_byte);

	restor_intr (&ps); /*     */
	enable_all_intr(); /*    */
}

/*   clkinit       */

void interrupt clkint()
{
	asm mov  al, 20h; /*    8159    */
    asm mov  dx, 20h; /*  */
    asm out  dx,al;

	preempt--;		/*     preemt   */
    if (preempt==0)    /*  ,       */
   		reschedule (); /*  reschedule */

}

/*   clkinit     ..,   */
/*   . */

void clkinit()
{
	IrqHandler_For_Clk = (void interrupt (*)())getvec(0x08); /*       */
	setvec(0x08,clkint); /*        */
	setclkrate(); /*      */
	preempt = QUANTUM; /*     preempt */
}

